<template>
  <section class="">

      <MessageBox type="simulateur" icon='images/warning.png' v-if="egalite == 1" :message="'La simulation n\'est pas possible. Deux listes ont la même moyenne et le même nombre de suffrages.En application de l\'article L. 262, le siège est attribué au plus âgé des candidats susceptibles d\'être proclamés élus..'" />

      <h3 v-if="tour == 0" v-html="$t('resultats.titleresulats_tour_1')"></h3>
      <h3 v-else v-html="$t('resultats.titleresulats_tour_2')"></h3>
      <table class="table">
          <thead>
              <tr>
                  <td colspan="2"></td>
                  <td class="design">

                          nb. de voix estimé

                      <span style="float:right; display: inline-block">
                          <b-button id="popup-nombre-estime" class="btn btn-popup">?</b-button>
                          <b-popover ref="popover" target="popup-nombre-estime" triggers="focus">
                              Calculé en fonction du pourcentage saisi et du nombre de suffrages exprimés
                          </b-popover>
                      </span>
                  </td>
                  <td class="design design-elus" colspan="2" v-if="ville.Nb_elus_conseilsecteur">
                      <span v-if="deuxieme_tour && tour == 0">Résultats</span>
                      <span v-else>&Eacute;lus</span>

                      <div class="resultats-mobile">
                          <div v-if="ville.Id_ville_insee == 75056 || (ville.Id_ville_insee >= 75101 && ville.Id_ville_insee <= 75120)">
                              de Paris
                          </div>
                          <div v-else>
                              Municipale
                          </div>
                          <div>
                              de Secteur
                          </div>
                      </div>
                  </td>
                  <td class="design" v-else>
                      <span v-if="deuxieme_tour && tour == 0">Résultats</span>
                      <span v-else>&Eacute;lus</span>
                  </td>
              </tr>
          </thead>
          <tbody>
              <template v-for="(line, index) in lines">
              <tr  v-bind:key="index" :class="[ line.css ]">
                  <td>
                      <span>{{ index + 1 }}.</span>

                      <span class="liste-title">{{ line.nom }}</span>
                  </td>
                  <td class="pourcentage">
                      {{ line.pourcentage }}%
                  </td>

                  <td data-label="(voix)" class="population add-label-mobile text-center">{{ line.populationVotante }} </td>

                  <td data-label="Résultats" class="resultats hidden-mobile" v-if="deuxieme_tour && tour == 0 && !line.autre">

                      <span v-if="line.pourcentage >= 10">Qualifié pour le second tour</span>

                      <span v-else-if="line.pourcentage >= 5">Peut fusionner</span>

                      <span v-else>&Eacute;liminé</span>
                  </td>

                  <td data-label="(nombres d'élus)" v-if="deuxieme_tour == false && !line.autre" class="resultats-sieges add-label-mobile hidden-mobile text-center">
                      {{ line.siege }}
                  </td>
                  <td data-label="(nombres d'élus)" v-if="deuxieme_tour == false && ville.secteurCalcul && !line.autre" class="resultats-sieges add-label-mobile hidden-mobile text-center">
                      {{ line.siegeSecteur }}
                  </td>
              </tr>
              <tr class="show-mobile" :class="[ line.css ]" v-bind:key="`${index}_${index+1}`">

                  <td colspan="3" data-label="(nb. de voix estimé)" v-if="deuxieme_tour && tour == 0 && !line.autre">

                      <span v-if="line.pourcentage >= 10">qualifié pour le second tour</span>

                      <span v-else-if="line.pourcentage >= 5">peut fusionner</span>

                      <span v-else>éliminé</span>
                  </td>
                  <td colspan="3" v-if="deuxieme_tour == false && !line.autre" class="resultats add-label-mobile">
                      <div class="resultats-mobile">
                          <div data-label="sièges">
                              {{ line.siege }}
                          </div>
                          <div data-label="sièges de secteur" v-if="line.siegeSecteur">
                              {{ line.siegeSecteur }}
                          </div>
                      </div>
                  </td>
              </tr>
            </template>
          </tbody>
      </table>
  </section>
</template>

<script>

import { villeGetters } from '@/store/ville.js';

import MessageBox from '@/components/simulateur/parts/MessageBox.vue'

export default {
  name: 'resultats',
  data () {
    return {
      localStorage: [],
      lines: [],
      deuxieme_tour: true,
      egalite: false
    }
  },
  components: {
      MessageBox
  },
  computed: {
      ...villeGetters
  },
  methods: {
      startCalcul(populationVotante)
      {
          let siegeAttribuer = 0;
          let siegeSecteurAttribuer = 0;

          this.lines.forEach((item, index) => {

              let val = this.calcul(item, index, siegeAttribuer, siegeSecteurAttribuer, populationVotante);

              siegeAttribuer = val.siegeAttribuer;
              siegeSecteurAttribuer = val.siegeSecteurAttribuer;
          });

          return {siegeAttribuer, siegeSecteurAttribuer}
      },
      calcul(item, index, siegeAttribuer, siegeSecteurAttribuer, populationVotante)
      {
          let siege = 0;
          let siegeSecteur = 0;
          let ville = this.ville;

          if(item.pourcentage > 0)
          {
              let quotientElectoral = populationVotante / ville.siegeRestant;
              let quotientElectoralSecteur = populationVotante / ville.siegeSecteurRestant;

              // Calcul de la population votante à partir du pourcentage : arrondis vers l'inférieur
              this.lines[index].populationVotante = Math.round(this.currentSuffrages * (item.pourcentage/100));

              this.lines[index].quotientElectoral = Math.floor(this.lines[index].populationVotante / quotientElectoral);
              this.lines[index].NbSiegeViaQES = Math.floor(this.lines[index].populationVotante / quotientElectoralSecteur);

              // Si c'est la liste majoritaire
              if(item.pourcentage == this.majorite){
                  siege += ville.siegeMajoritaire;
                  siegeSecteur += ville.siegeSecteurMajoritaire;
              }

              siegeAttribuer += this.lines[index].siege = this.lines[index].quotientElectoral + siege;

              siegeSecteurAttribuer += this.lines[index].siegeSecteur = this.lines[index].NbSiegeViaQES + siegeSecteur;

              this.lines[index].rapport = this.lines[index].populationVotante / (this.lines[index].quotientElectoral + 1);
              this.lines[index].rapportSecteur = this.lines[index].populationVotante / (this.lines[index].NbSiegeViaQES + 1);

          }
          else{
              this.lines[index].populationVotante = 0;
              this.lines[index].pourcentage = 0;
              this.lines[index].siege = 0;
              this.lines[index].rapport = 0;
          }

          return {siegeAttribuer, siegeSecteurAttribuer};
      },
      calculTest(siegeSecteurAttribuer)
      {
          let siegeSecteurTour = 0;
          let lines = this.lines;
          let egalite = 0;

          while(siegeSecteurTour < (this.ville.Nb_elus_conseilsecteur - siegeSecteurAttribuer)){

              lines.sort(function (a, b) {
                  let resultat = b.rapportSecteur - a.rapportSecteur;

                  if(b.rapportSecteur == a.rapportSecteur && b.populationVotante != a.populationVotante){
                      resultat = b.populationVotante - a.populationVotante;
                  }
                  else if((b.rapportSecteur == a.rapportSecteur && b.populationVotante == a.populationVotante) && b.pourcentage != 0){
                      egalite = true;
                  }

                  return resultat;

              });

              lines[0].siegeSecteur += 1;
              lines[0].NbSiegeViaQES += 1;
              lines[0].rapportSecteur = lines[0].populationVotante / (lines[0].NbSiegeViaQES + 1);

              if(this.tour == 1) lines[0].css = 'victoire'

              siegeSecteurTour ++;
          }

          this.egalite = egalite;
          return lines;
      },
      async calculTestClassic(siegeAttribuer)
      {
          let siegeTour = 0;
          let egalite = false;

          if(this.egalite){
              return false;
          }

          while(siegeTour < (this.ville.Nb_elus_municipaux - siegeAttribuer)){

              this.lines.sort(function (a, b) {
                  let resultat = b.rapport - a.rapport;

                  if(b.rapport == a.rapport && b.populationVotante != a.populationVotante){
                      resultat = b.populationVotante - a.populationVotante;
                  }
                  else if((b.rapport == a.rapport && b.populationVotante == a.populationVotante) && b.pourcentage != 0){
                      egalite = true;
                  }

                  return resultat;
              });

              this.lines[0].siege += 1;
              this.lines[0].quotientElectoral += 1;
              this.lines[0].rapport = this.lines[0].populationVotante / (this.lines[0].quotientElectoral + 1);

              if(this.tour == 1) this.lines[0].css = 'victoire'

              siegeTour ++;
          }

          this.egalite = egalite;
          return true;
      }
  },
  //Au chargement
  async mounted () {
      if (localStorage.datas) {
        this.deuxieme_tour = true;

        this.localStorage = JSON.parse(localStorage.datas);

        if(this.localStorage[this.ville.Id_ville_insee][this.tour] != undefined){
            this.lines = this.localStorage[this.ville.Id_ville_insee][this.tour];
        }

        //On récupère le total de pourcentage attribuer par l'utilisateur
        let pourcentageUtilisateur = this.lines.reduce((acc, val) => acc + parseFloat(val.pourcentage), 0);

        //On récupère le pourcentage le plus élevé
        this.majorite = Math.max.apply(Math, this.lines.map(function(o) { return o.pourcentage; }));
        if(this.majorite >= 50 || this.tour == 1){
            this.deuxieme_tour = false;
        }


        let populationVotante = 0;
        this.lines.forEach((item) => {
            if(item.pourcentage > 4.99999){
                populationVotante += Math.round(this.currentSuffrages * (parseFloat(item.pourcentage)/100));
            }
        });

        let val = await this.startCalcul(populationVotante);

        this.lines = await this.calculTest(val.siegeSecteurAttribuer);
        await this.calculTestClassic(val.siegeAttribuer, populationVotante);

        this.lines.forEach((item) => {
            if(this.egalite){
                item.siege = 0;
                item.siegeSecteur = 0;
                item.css = 'egalite';
            }
            else{
                item.css = 'defaite';
                if(this.deuxieme_tour && this.tour == 0){
                    if(item.pourcentage >= 10){
                        item.css = 'qualifie';
                    }
                    else if(item.pourcentage >= 5){
                        item.css = 'fusion';
                    }
                    else {
                      item.css = 'elimines';
                    }
                }
                else if(item.siege || item.siegeSecteur){
                    item.css = 'victoire'
                }
            }
        });

        this.lines.sort(function (a, b) {
          return b.pourcentage - a.pourcentage;
        });

        if(pourcentageUtilisateur < 100){
            this.lines.push({
                nom: 'autre(s) liste(s)',
                pourcentage: (100 - pourcentageUtilisateur).toFixed(2),
                autre: 1,
                populationVotante: Math.floor(populationVotante * ((100 - pourcentageUtilisateur) /100))
            });
        }

      }

      this.$emit('deuxiemeTour', this.deuxieme_tour );
  }
}
</script>
